/* Program: xbasic.c
   Programmer: JRDM
   Date: / /97
  
   Purpose: this program is a base for an X program ...
   */

/* Xlib include files */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>

/* standard C include files */
#include <stdio.h>

/* bitmap data for icon */
#include "bitmaps/icon_bitmap"
#define BITMAPDEPTH 1

/* do we have enough room */
#define TOO_SMALL 0
#define BIG_ENOUGH 1

/* Display and screen_num are used as arguments to nearly every
 * Xlib routine, so it simplifies routine calls to declare them
 * global; if there were additional source files, these veriables
 * would be declared "extern" in them */
Display *display;
int screen_num

/* function prototypes */
/* none so far */
/* Name this program was invoked by; this is global because
 * it is used in several places in application routines, not
 * just in main */
static char *progname;

/******************************************************************/
void main(argc, argv)
int argc;
char **argv;
{
  Window win;
  unsigned int width, height;        /* window size */
  int x, y;                          /* window position */
  unsigned int border_width = 4;     /* four pixels */
  unsigned int display_width, display_height;
  unsigned int icon_width, icon_height;
  char *window_name = "Basic Window Program";
  char *icon_name = "basicwin";
  Pixmap icon_pixmap;
  XSizeHints *size_hints
  XIconSize *size_list;
  XWMHints *wm_hints;
  XClassHint *class_hints;
  XTextProperty windowName, iconName;
  int count;
  XEvent report;
  GC gc;
  XFontStruct *font_info;
  char *display_name = NULL;
  int window_size = 0;   /* BIG_ENOUGH or TOO_SMALL to display contents */

  progname = argv[0];

  if (!(size_hints = XAllocSizeHints())) {
       fprintf(stderr, "%s: failure allocating memory\n", progname);
  }
  if (!(wm_hints = XAllocWMHints())) {
       fprintf(stderr, "%s: failure allocating memory\n", progname);
  }
  if (!(class_hints = XAllocClassHint())) {
       fprintf(stderr, "%s: failure allocating memory\n", progname);
  }
  /* Connect to X server */
  if ( (display=XOpenDisplay(display_name)) == NULL )
    {
      (void) fprintf( stderr, "%s: cannot connect to X server %s\n",
		      progname, XDisplayName(display_name));
      exit(-1);
    }

  /* Get screen size from display structure macro */
  screen_num = DefaultScreen(display);
  display_width = DisplayWidth(display, screen_num);
  display_height = DisplayHeight(display, screen_num);

  /* Note that in a real application, x and y would default
   * to 0 but would be settable from the command line or a
   * resource database */
  x = y = 0;

  /* Size window with enough room for text */
  width = display_width/3, height = display_height/4;

  /* Create opaque window */
  win = XCreateSimpleWindow(display, RootWindow(display,screen_num),
	     x, y, width, height, border_width, BlackPixel(display,
	     screen_num), WhitePixel(display,screen_num));

  /* Get available icon size from window manager */

  if (XGetIconSizes(display, RootWindow(display,screen_num),
             &size_list, &count) == 0)
       (void)
  printf(" \n");
  return(0);
}
/******************************************************************/
